(*
   #######################################################################
   # NOTAS SOBRE DIREITO AUTORAL                                         #
   # Direitos Autorais (c) 1997, 98, 99 Alan Candido & AC WebPlanner     #
   # Todos os direitos reservados                                        #
   #                                                                     #
   # Esta rotina, pode ser atualizada, modificada, copiada e distribuda #
   # por qualquer pessoa, em qualquer tempo, desde que esta nota de di-  #
   # reito autoral e demais comentrios sejam mantidos, sem modifies   #
   # de contedo, forma ou apresentao.                                 #
   # Por usar este cdigo, voc concondar com estas normas e reconhece   #
   # Alan Candido como legal detentor dos direitos autorais e comprome-  #
   # te-se a inserir uma nota, na caixa "Sobre..." dos aplicativos que   #
   # fizerem uso desta, com o endereo do meu "site"(1).                 #
   # Alan Candido & AC WebPlanner no se resposabilizam pelo uso deste   #
   # ou por problemas que este causar a seus usurios.                   #
   # A venda, distribuio ou qualquer forma de comercializao deste    #
   # cdigo, por terceiros,  expressamente proibida.                    #
   # Aqueles que infrigirem estas normas e leis sobre direitos autorais  #
   # ficar sujeito as sanes e penalidades legais, podendo responder   #
   # civil e criminalmente.                                              #
   #---------------------------------------------------------------------#
   # Se desejar, envie sugestes ou as modificaces efetuadas, para que  #
   # ela (modificao) e voc, passem a fazer parte da verso oficial.   #
   #---------------------------------------------------------------------#
   # Caso voce encontre algum erro (bug), entre em contato, via e-mail,  #
   # para que possamos corrigi-lo.                                       #
   #---------------------------------------------------------------------#
   # (1) ACWebPlanner - www.terravista.ciclone.com.br/praiabrava/1932    #
   # (2) Nosso e-mail - acandido@zipmail.com.br                          #
   #######################################################################
   # TACComboBox2 - Instrues de uso                                    #
   #---------------------------------------------------------------------#
   #                                                                     #
   # Este componente  derivado do TComoBox, portanto a funcionalidade   #
   # bsica  a mesma. A funo deste  permitir, ao programador ou ana- #
   # lista incluir tens que no podem ser selecionados (texto esttico).#
   # Os textos estticos so identificados por um hifem (-) no nicio da #
   # descrio do tem, dentro da lista de tens (propriedade Items)     #
   # Exemplo:                                                            #
   #    Image que voc quer apresentar uma lista com os funcionrios de  #
   #    um departamento, agrupados por empresa. A propriedade Items fi-  #
   #    r assim:                                                        #
   #        -RH                                                          #
   #        D. Pedro I                                                   #
   #        Marquesa de Santos                                           #
   #        -Cobrana                                                    #
   #        D. Pedro II                                                  #
   #        -Jurdico                                                    #
   #        Rui Barbosa                                                  #
   #    Desta forma, somente o nome das pessoas podero ser selecionados #
   #    e os departamentos no. Vale lembrar que o texto esttico tambm #
   #     um tem, portanto, as propriedades que trabalham com o nmero  #
   #    ou quantidade de itens so afetados.                             #
   #                                                                     #
   # Importante: A proriedade Style no deve ser modificada              #
   #                                                                     #
   #######################################################################
   # Versao # Autor/Data   # Comentarios                                 #
   #######################################################################
   # 0.0.1  # Alan Candido # Definio e criao do componenete          #
   #        # 01.01.99     #                                             #
   #######################################################################
*)

unit uComboBox;

interface

uses
  Windows, Messages, StdCtrls, Controls, Classes;

type
//--< Prototipao do Componente >----------------------------------------------
TACComboBox2 = class(TComboBox)
   private
      FOldItem: integer;
   protected
      procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
      procedure CNCommand(var Message: TWMCommand); message CN_COMMAND;
   public
      constructor Create(AOwner: TComponent); override;
end;

//--< Prototipao de rotinas pblicas >----------------------------------------
procedure Register;

implementation

uses
   Graphics;
   
{
################################################################################
Implementao de rotinas pblicas
################################################################################
Registro do componente
********************************************************************************
}
procedure Register;
begin
    RegisterComponents('AC WebPlanner', [TACComboBox2]);
end;

{
################################################################################
Implementao da classe TACComboBox2
################################################################################
Construtor da classe
********************************************************************************
}
constructor TACComboBox2.Create(AOwner: TComponent);
begin
   inherited;
   FOldItem := -1;
   Style := csOwnerDrawFixed;
end;

{
********************************************************************************
Destaca os itens com texto esttico
********************************************************************************
}
procedure TACComboBox2.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
   inherited;
   if Items[Index][1] = '-' then
   begin
      Canvas.FillRect(Rect);
      Canvas.Font.Color := clGrayText;
      Canvas.TextOut(Rect.Left + 2, Rect.Top, copy(Items[Index],2,length(Items[Index])-1));
   end;
end;

{
********************************************************************************
Processa as mensagens de notificao
********************************************************************************
}
procedure TACComboBox2.CNCOMMAND(var Message: TWMCommand);
begin
   case Message.NotifyCode of
      CBN_SELCHANGE:
         begin
            if Items[ItemIndex][1] <> '-' then
            begin
               FOldItem := ItemIndex;
               inherited;
            end else
            begin
               ItemIndex := FOldItem;
            end;
         end
   else
      inherited;
   end;
end;

end.
